require 'rails/generators'

module Interview
  module Generators
    class InstallGenerator < ::Rails::Generators::Base
      
      source_root File.expand_path("../templates", __FILE__)
      desc "This generator installs Interview"
      
      def add_view_controls
        empty_directory "app/view_controls"
      end
      
      def add_assets
        copy_file "application.css", "app/assets/stylesheets/application.css" # todo: überdenken
        copy_file "colors.css.scss", "app/assets/stylesheets/colors.css.scss"
        copy_file "application.js", "app/assets/javascripts/application.js" # todo: überdenken
        copy_file "missing_thumb.png", "app/assets/images/missing_thumb.png"
        copy_file "missing_medium.png", "app/assets/images/missing_medium.png"
        copy_file "missing_large.png", "app/assets/images/missing_large.png"
        copy_file "32px.png", "app/assets/images/32px.png"
        copy_file "40px.png", "app/assets/images/40px.png"
        copy_file "throbber.gif", "app/assets/images/throbber.gif"
        copy_file "jstree.css", "app/assets/stylesheets/jstree.css"
        copy_file "jstree.js", "app/assets/javascripts/jstree.js"
        copy_file "blueimp-gallery.css", "app/assets/stylesheets/blueimp-gallery.css"
        copy_file "blueimp-gallery.js", "app/assets/javascripts/blueimp-gallery.js"
      end
      
      def add_initializers
        copy_file "interview.rb", "config/initializers/interview.rb" # todo: überarbeiten
      end
      
      def add_locales
        copy_file "defaults_de.yml", "config/locales/defaults_de.yml"
        empty_directory "config/locales/views"
        copy_file "views_defaults_de.yml", "config/locales/views/defaults_de.yml"
        empty_directory "config/locales/models"
      end
      
      def install_ckeditor
        empty_directory "app/assets/javascripts/ckeditor"
        copy_file "ckeditor_config.js", "app/assets/javascripts/ckeditor/config.js"
      end
      
    end
  end
end