require "active_support/inflector"
require "draper"
require "builder"

require "interview/version"

require "interview/control"
require "interview/meta_control"
require "interview/has_html_options"
require "interview/builder"
require "interview/nested_buildable"
require "interview/handler"
require "interview/engine"
require "interview/object_context"
require "interview/association_methods"

require "interview/controls/section"
require "interview/controls/text"
require "interview/controls/html_headers"
require "interview/controls/container"
require "interview/controls/link"
require "interview/controls/dropdown"
require "interview/controls/space"
require "interview/controls/glyphicon"
require "interview/controls/tooltip"
require "interview/controls/html_control"
require "interview/controls/actionbar"
require "interview/controls/grid"
require "interview/controls/list"
require "interview/controls/tree"
require "interview/controls/navigation"
require "interview/controls/navigation_item"
require "interview/controls/tabs"
require "interview/controls/tab_box"
require "interview/controls/tab"
require "interview/controls/breadcrumbs"
require "interview/controls/media_object"
require "interview/controls/panel"
require "interview/controls/collapse_container"
require "interview/controls/pagination"
require "interview/controls/html_doctype"
require "interview/controls/alert"

require "interview/controls/attribute"
require "interview/controls/string_attribute"
require "interview/controls/text_attribute"
require "interview/controls/integer_attribute"
require "interview/controls/decimal_attribute"
require "interview/controls/boolean_attribute"
require "interview/controls/date_attribute"
require "interview/controls/datetime_attribute"
require "interview/controls/option_attribute"
require "interview/controls/html_text_attribute"
require "interview/controls/image_attribute"
require "interview/controls/image_gallery_attribute"
require "interview/controls/image_light_box"
require "interview/controls/association_attribute"
require "interview/controls/association_list_attribute"
require "interview/controls/hidden_attribute"
require "interview/controls/container_attribute"

require "interview/controls/view"
require "interview/controls/form"
require "interview/controls/nested_form"
require "interview/controls/nested_form_remove_link"
require "interview/controls/nested_form_add_link"
require "interview/controls/nested_form_add_images"
require "interview/controls/form_errors"
require "interview/controls/polymorphic_nested_form"
require "interview/controls/polymorphic_add_link"
require "interview/controls/search_form"
require "interview/controls/submit"
require "interview/controls/button"
require "interview/controls/progress_bar"
require "interview/controls/horizontal_form_container"
require "interview/controls/scaffold_card"
require "interview/controls/scaffold_form"

module Interview
  # Your code goes here...
end

module ActiveRecord
  class Base
    
    before_save :set_human_id
    
    def set_human_id
      if respond_to? :human_id
        if respond_to? :name
          self.human_id = self.name.to_s
        elsif respond_to? :title
          self.human_id = self.title.to_s
        elsif respond_to? :description
          self.human_id = self.description.to_s
        else
          self.human_id = self.id.to_s
        end
      end
    end
    
    def self.human_ids
      objects = select("\"#{self.table_name}\".\"human_id\"").order(:human_id)
      return objects.map { |object| object.human_id }
    end
    
    def self.human_name(options={})
      options = {scope: [self.i18n_scope, :models], count: 1}.merge(options)
      I18n.translate(self.name.underscore, options)
    end
  
  end
end