module Interview
  class Control
    include Draper::ViewHelpers
    
    attr_accessor :parent
    
    def initialize(params={})
      set_attributes(params)
      set_defaults
    end
    
    def set_attributes(params={})
      params.each do |key, value|
        key = "#{key}=".to_sym
        if respond_to?(key) # and not value.nil?
          send(key, value)
        end
      end
    end
    
    def set_defaults # todo: löschen?
      if self.class.const_defined? 'DEFAULTS'
        self.class::DEFAULTS.each do |key, value|
          self.send("#{key}=".to_sym, value)
        end
      end
    end
    
    def ancestors
      if @parent.nil?
        return []
      else
        return [@parent] + @parent.ancestors
      end
    end
    
    def find_attribute(attribute)
      if respond_to? attribute
        value = send attribute
        return value if value
      end
      if @parent
        return @parent.find_attribute(attribute)
      else
        return nil
      end
      # return nil if @parent.nil?
      # if @parent.respond_to? attribute
        # return @parent.send attribute
      # else
        # return @parent.find_attribute attribute
      # end
    end
    
    def find_attribute!(attr_name)
      attribute = find_attribute(attr_name)
      throw "Attribute #{attr_name} was not found." if attribute.nil?
      return attribute
    end
    
    def build(b)
      yield if block_given?
    end
    
    def build_with_params(b, params={})
      set_attributes(params)
      build(b)
    end
    
    def build_child(b, control, &block)
      b.add! control, &block
    end
    
  end
end