module Interview
  class Actionbar < Control
    
    attr_accessor :title, :icon
    
    def build(b)
      title = @title || find_attribute(:title)
      icon = @icon
      if icon == :polymorphic
        object = find_attribute! :object
        icon = object.icon
      end
      
      b.section html_class: 'clearfix' do
        if block_given?
          b.section style: 'ul', html_class: 'list-inline pull-right' do
            b.meta_class pointer: self do
              yield
            end
          end
        end
        if title
          b.section style: 'p', html_class: 'h3' do
            if icon
              b.section style: 'span', html_class: icon
              b.space
            end
            b.text text: title
          end
        end
      end
    end
    
    def build_child(b, control, &block)
      b.section style: 'li' do
        super
      end
    end
    
  end
end