module Interview
  class Attribute < Control
    
    include HasHtmlOptions # todo: delete?
    
    # todo: Idee lookup_object methoden einbauen
    
    attr_accessor :object, :method, :caption, :value, :style, :link, 
      :tooltip, :nil_value, :caption_as_placeholder
    
    def value
      return @value if @value
      
      object = @object || find_attribute!(:object)
      if object.respond_to? @method
        val = object.send @method
      end
      val = @nil_value if val.nil?
      return val
    end
    
    def build_caption(b)
      @parent ||= b.curr_parent
      b.text text: caption
    end
    
    def caption
      return @caption if @caption
        
      object = @object || find_attribute!(:object)
      return object.class.human_attribute_name(@method)
    end
    
    def tooltip
      return @tooltip if @tooltip
      
      object = @object || find_attribute!(:object)
      tooltip = h.t("activerecord.attribute_tooltips.#{object.class.model_name.i18n_key}.#{@method}", default: '')
      tooltip = :hide if tooltip == ''
      return tooltip
    end
    
    def build(b, &block)
      if @style == 'write'
        build_write(b, &block)
      else
        build_read(b, &block)
      end
    end
    
    protected
    
    def build_read(b)
      add_link(b) do
        b.text text: value.to_s
      end
    end
    
    def build_write(b)
      opts = { class: 'form-control' }
      opts[:placeholder] = caption if @caption_as_placeholder
      b << form_builder.text_field(@method, opts)
    end
    
    def form_builder
      return find_attribute! :form_builder
    end
    
    def add_link(b)
      if @link
        b.link do
          yield
        end
      else
        yield
      end
    end
    
  end
end