module Interview
  class Form < Control
    
    include HasHtmlOptions, NestedBuildable
    
    attr_accessor :object, :redirect_to
    attr_reader :form_builder
    
    def build(b)
      object = @object || find_attribute!(:object)
      b << h.form_for(object, role: 'form', html: options_to_html) do |form_builder|
        @form_builder = form_builder
        create_nested_builder(b)
        
        b.form_errors
        build_default_controls(b)
        
        yield if block_given?
        
        render_nested_builder(b)
      end
    end
    
    protected
    
    def build_default_controls(b) # todo: auslagern?
      if @redirect_to == :parent and Object.const_defined? 'Gretel'
        b << h.hidden_field_tag('redirect_to', h.parent_breadcrumb.url)
      elsif @redirect_to == :current
        b << h.hidden_field_tag('redirect_to', h.request.original_url)
      end
    end
    
  end
end