module Interview
  class MediaObject < Control
    
    def build(b)
      b.section html_class: 'media' do
        b.meta_control pointer: self do
          @child_no = 0
          yield if block_given?
        end
        b << '</div>' if @child_no >= 2
      end
    end 
    
    def build_child(b, control, &block)
      @child_no += 1
      if @child_no == 1
        if control.respond_to? :html_class
          control.html_class = 'pull-left'
          super
        else
          b.section html_class: 'pull-left' do
            super
          end
        end
        
      elsif @child_no == 2
        b << '<div class="media-body">'
        control.html_class = 'media-heading' if control.respond_to? :html_class
        super
        
      else
        super
      end
    end
    
  end
end