module Interview
  class NavigationItem < Link
    
    attr_accessor :active, :level, :badge_formula
    
    def build(b)
      set_level
      html_class = ["level#{@level}"]
      html_class << 'active' if @active
      b.section style: 'li', html_class: html_class do
        super(b) do
          badge = @badge_formula.call if @badge_formula 
          unless badge.nil? or badge == 0 or badge == ''
            b.text text: badge.to_s, style: 'span', html_class: 'badge pull-right'
          end
        end
      end
      yield if block_given?
    end
    
    protected
    
    def set_level
      return if @level
      if level = find_attribute(:level)
        @level = level + 1
      else
        @level = 0
      end
    end
    
  end
end