module Interview
  class NestedForm < Control
    
    include NestedBuildable
    
    attr_accessor :image_based # todo: move to an other control?
    attr_reader :form_builder, :object
    
    def build(b, &block)
      assoc_form_builder = find_attribute! :form_builder
      assoc_method = find_attribute! :assoc_method
      
      b.section html_class: 'nested_form_container' do # todo: class überarbeiten
        if @image_based
          b.nested_form_add_images
        end
        b << assoc_form_builder.fields_for(assoc_method.to_sym) do |form_builder|
          render_nested_form(b, form_builder, &block)
        end
        b.section style: 'script', html_class: 'nested_form_script', html_options: { type: 'text/x-tmpl' } do
          new_object = assoc_form_builder.object.association(assoc_method.to_sym).build # todo: polymorphic add link
          b << assoc_form_builder.fields_for(assoc_method.to_sym, new_object, :child_index => "${index}") do |form_builder|
            render_nested_form(b, form_builder, &block)
          end
        end
      end
    end
    
    def render_nested_form(b, form_builder)
      create_nested_builder(b)
      @form_builder = form_builder
      @object = form_builder.object
      b.section html_class: 'nested_form collapse in' do
        yield if block_given?
        b << form_builder.hidden_field(:id)
        b << form_builder.hidden_field(:_destroy, class: 'nested_form_destroy')
        if @image_based
          b << form_builder.hidden_field(:upload_buffer_id, class: 'upload_buffer_id')
        end
      end
      return render_nested_builder(b)
    end
    
  end
end