module Interview
  class Tab < Control
    
    include HasHtmlOptions
    
    attr_accessor :caption, :active
    
    def build(b)
      html_class = @html_class.dup
      html_options = @html_options.dup
      html_class << 'tab-pane'
      html_class << 'active' if @active
      html_options[:id] = @caption if @caption
      b.section html_class: html_class, html_options: html_options do
        yield if block_given?
      end
    end
    
    def build_caption(b)
      html_class = control.active ? 'active' : ''
      b.section style: 'li', html_class: html_class do
        b.link caption: @caption, url: "##{@caption}", html_options: { data: { toogle: 'tab' } }
      end
    end
    
  end
end