module Interview
  class Text < Control
    
    include HasHtmlOptions
    
    attr_accessor :text, :style, :html_safe
    
    def build(b)
      if @style
        b.section style: @style, html_class: @html_class, html_options: @html_options do
          build_text(b)
          yield if block_given?
        end
      else
        build_text(b)
        yield if block_given?
      end
    end
    
    protected
    
    def build_text(b)
      if @text
        if @html_safe
          b.html << @text
        else
          b.html.text! @text
        end
      end
    end
    
  end
end