module Interview
  class TextAttribute < Attribute
    
    attr_accessor :line_break, :cut, :rows
    
    protected
    
    def build_read(b)
      return if value.nil?
      line_break = @line_break || true
      
      value = self.value.gsub(/\n/, '<br/>') if line_break
      value = value[0..29] + '...' if @cut and value.size > 30
      b << value.html_safe
    end
    
    def build_write(b)
      rows = @rows || 8
      b << form_builder.text_area(@method, class: 'form-control', rows: rows)
    end
    
  end
end