module Interview
  class View < Control
    
    attr_accessor :object, :objects, :filter, :scope, :title, :auto_title_for
    attr_reader :assoc_object, :assoc_method
    
    def nested_form
      return siblings.find { |sib| sib.is_a? Interview::NestedForm }
    end
    
    def title
      if @title # todo: Benötige ich den Titel?
        return @title
      elsif @auto_title_for
        return case @auto_title_for.to_sym
        when :collection
          if @assoc_object
            @assoc_object.class.human_attribute_name(@assoc_method)
          else
            @object.class.human_name(count: 2)
          end
        when :object
          @object.human_id
        when :form
          text = @object.created_at ? 'views.edit' : 'views.new'
          h.t(text, model: @object.class.human_name )
        end
      end
    end
    
    def singular_title # todo: Überdenken
      if @auto_title_for
        if @assoc_object
          return @assoc_object.class.human_attribute_name(@assoc_method.to_s.singularize)
        else
          return @object.class.human_name
        end
      end
    end
    
    def tooltip
      defaults = @object.class.lookup_ancestors.map do |klass|
        klass.name.underscore.to_sym
      end
      defaults << ''
      
      options = { :scope => [@object.class.i18n_scope, :model_tooltips], :default => defaults }
      return I18n.translate(defaults.shift, options)
      
      # return h.t("activerecord.model_tooltips.#{@object.class.name.underscore}", default: '')
      # todo: tooltip von Elternelement verwenden, falls nicht vorhanden.
    end
    
    def build(b)
      tmp_object = @object
      tmp_objects = @objects
      
      if @object.is_a? String
        # if Object::const_defined?(@object.camelcase) # todo: Überdenken!
        #   @object = @object.camelcase.constantize.new
        # else
          @assoc_object = @parent.find_attribute! :object
          @object = @object.split('.').inject(@assoc_object, :send)
        # end
      elsif @object.is_a? Proc  
        @assoc_object = @parent.find_attribute! :object
        @object = @object.call(@assoc_object, self)
      elsif @object.is_a? Class
        @object = @object.new
      elsif @object.nil?
        @object = find_attribute! :object
      end
      
      if @objects.is_a? String
        @assoc_object = find_attribute! :object
        @assoc_method = @objects
        
        @objects = @assoc_method.split('.').inject(@assoc_object, :send)
        # @objects = @assoc_object.send @assoc_method
        @objects = @objects.send @scope if @scope
        @object = @objects.klass.new
        @scope = nil
        @filter = { "#{assoc_object.class.name.underscore}_id" => assoc_object.id }
      end
      
      if Object.const_defined? 'Gretel' and parent.nil?
        model_name = @object.class.lookup_ancestors.last.model_name
        case h.action_name
        when 'index'
          h.breadcrumb model_name.plural.to_sym
        when 'show'
          h.breadcrumb model_name.singular.to_sym, @object
        when 'new'
          h.breadcrumb "new_#{model_name.singular}".to_sym, @object
        when 'edit'
          h.breadcrumb "edit_#{model_name.singular}".to_sym, @object
        end
      end
      
      yield if block_given?
      
      @object = tmp_object
      @objects = tmp_objects
    end
      
  end
end