module Interview
  module HasHtmlOptions
    
    attr_accessor :html_options, :html_class
    
    def initialize(params={})
      @html_options = {}
      @html_class = []
      super
    end
    
    def html_class=(html_class)
      if html_class.is_a? Array
        @html_class = html_class
      elsif html_class.is_a? String
        @html_class += html_class.split
      end
    end
    
    protected
    
    def options_to_html(html_options = @html_options, html_class = @html_class)
      opts = html_options.dup
      opts[:class] = html_class.join(' ') unless html_class.empty?
      return opts
    end
    
  end
end